stages:
  - build
  - deploy

compile:
  image: golang:1.22.2
  stage: build
  cache:
    paths:
      - .cache
  script:
    - mkdir -p .cache
    - export GO111MODULE=on
    - go install "github.com/caddyserver/xcaddy/cmd/xcaddy@latest"
    - GOOS=linux xcaddy build --with "github.com/tailscale/caddy-tailscale" --with "github.com/pteich/caddy-tlsconsul@v1.4.0" --with "github.com/greenpau/caddy-security@v1.1.29" --with "github.com/enum-gg/caddy-discord@v1.2.0" --with "github.com/caddy-dns/cloudflare" --with "github.com/RussellLuo/caddy-ext/dynamichandler" --with "github.com/RussellLuo/caddy-ext/flagr" --with "github.com/RussellLuo/caddy-ext/layer4" --with "github.com/RussellLuo/caddy-ext/ratelimit@v0.3.0" --with "github.com/RussellLuo/caddy-ext/requestbodyvar" --with "github.com/abiosoft/caddy-json-parse" --with "github.com/pberkel/caddy-storage-redis@v1.2.0" --with "github.com/lucaslorentz/caddy-docker-proxy/v2@v2.8.11" --with "github.com/evalphobia/logrus_sentry@v0.8.2" --with "go.mongodb.org/mongo-driver/mongo@v1.15.0"
  artifacts:
    paths:
      - caddy

docker:
  image: docker:24.0.5
  services:
    - docker:24.0.5-dind
  before_script:
    - docker login -u chulehuyvu --password-stdin
  variables:
    DOCKER_DRIVER: overlay2
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  stage: build
  script:
    - docker compose -f docker-compose.yml up -d -t $IMAGE_TAG .
    - docker tag $IMAGE_TAG
    - docker push $IMAGE_TAG

deploy-binary:
  needs:
    - artifacts: true
      job: compile
  
  stage: deploy
  script:
    - deploy.sh
